typedef struct filesels FILESELS;      
struct filesels{
        int used;
        int list;
        int ok;
        int cancel;
        int editbox;
        void (*CallBack)();
        char *data;
        char *mask;
        char selection[80];
        int winid;
        char dir[100];
	int parentwin;
};
FILESELS filesel[10];
void AddFileList(int id);

void FSDone(int id)
{
        filesel[id].used=0;
        CloseWin(filesel[id].winid);
        //strcpy(filesel[id].data,filesel[id].dir);
        //strcat(filesel[id].data,"\\");
        //strcat(filesel[id].data,listbox[filesel[id].list].selection);
        strcpy(filesel[id].data,filesel[id].selection);
        filesel[id].CallBack();
        //strcpy(filesel[id].data,"");
};

void FSCancel(int id)
{
        filesel[id].used=0;
        CloseWin(filesel[id].winid);
        strcpy(filesel[id].data,"");
	SetFocusOn(filesel[id].parentwin);
        //filesel[id].CallBack();
};

void MoveName(int id)
{
        struct ffblk f;
        char str[80];
        int temp;
        strcpy(filesel[id].selection,listbox[filesel[id].list].selection);
        //now we have to sort directories from real files
        //first see if the selection is really a file or not

        //it isn't a file its a directory
        //now see if user went up a level
        strcpy(str,filesel[id].selection);
        temp=strncmp(filesel[id].selection,"..",2);
        if(temp==1)
        {
                //user wants to go up a level
                strcpy(str,filesel[id].dir+strlen(filesel[id].dir)-strrchr(filesel[id].dir,"\\")-1);
                strcpy(filesel[id].dir,str);
        }
        else
        {
                strcat(filesel[id].dir,"\\");
                strcat(filesel[id].dir,filesel[id].selection);
        }
        strcpy(str,filesel[id].dir);
        temp=findfirst(str,&f,FA_DIREC);
        if(temp!=1)
                AddFileList(id);
        strcpy(filesel[id].selection,str);
	memset(str,0,sizeof(str));
	fixpath(filesel[id].selection,str);
	memset(filesel[id].selection,0,80);
	strlwr(str);
	strcpy(filesel[id].selection,str);
        RefreshListBox(filesel[id].list);
        RefreshEditBox(filesel[id].editbox);
        RefreshWin(filesel[id].winid);
};

void AddFileList(int id)
{
        struct ffblk f;
        int done;
        char str[100];
        ResetListBox(filesel[id].list);
        strcpy(str,filesel[id].dir);
        strcat(str,"\\");
        strcat(str,filesel[id].mask);
        //first we add directory entries
        done=findfirst(str,&f,FA_DIREC);
        while(!done)
        {
                AddListItem(filesel[id].list,f.ff_name);
                done=findnext(&f);
        }
};

void FSGoDriveA(int id)
{
        strcpy(filesel[id].dir,"A:");
        AddFileList(id);
        RefreshListBox(filesel[id].list);
        RefreshEditBox(filesel[id].editbox);
        RefreshWin(filesel[id].winid);

};

void FSGoDriveF(int id)
{
        strcpy(filesel[id].dir,"F:");
        AddFileList(id);
        RefreshListBox(filesel[id].list);
        RefreshEditBox(filesel[id].editbox);
        RefreshWin(filesel[id].winid);

};

void FSGoDriveC(int id)
{
        strcpy(filesel[id].dir,"C:");
        AddFileList(id);
        RefreshListBox(filesel[id].list);
        RefreshEditBox(filesel[id].editbox);
        RefreshWin(filesel[id].winid);

};

void FSGoDriveD(int id)
{
        strcpy(filesel[id].dir,"D:");
        AddFileList(id);
        RefreshListBox(filesel[id].list);
        RefreshEditBox(filesel[id].editbox);
        RefreshWin(filesel[id].winid);

};

void FSGoDriveE(int id)
{
        strcpy(filesel[id].dir,"E:");
        AddFileList(id);
        RefreshListBox(filesel[id].list);
        RefreshEditBox(filesel[id].editbox);
        RefreshWin(filesel[id].winid);

};

void FileSelector(char *dir,void (*CallBack)(),char *data)
{
        int temp;
        char str[60];
        temp=0;
        do{
                temp=temp+1;
                if(filesel[temp].used==0)
                {
                        filesel[temp].used=1;
                        filesel[temp].data=data;
                        filesel[temp].CallBack=CallBack;
			filesel[temp].parentwin=CurrentWindow();
                        filesel[temp].winid=MakeWindow(50,50,403,414,"Choose A Filename",BlankHandler,0);
                        filesel[temp].list=AddListBox(filesel[temp].winid,2,24,36,22,MoveName,temp);
                        filesel[temp].ok=MakeButton(filesel[temp].winid,2,394,"Okay",FSDone,temp);
                        filesel[temp].ok=MakeButton(filesel[temp].winid,45,394,"Cancel",FSCancel,temp);
                        filesel[temp].ok=MakeButton(filesel[temp].winid,2,357,"DRIVE A:",FSGoDriveA,temp);
                        filesel[temp].ok=MakeButton(filesel[temp].winid,81,357,"DRIVE C:",FSGoDriveC,temp);
                        filesel[temp].ok=MakeButton(filesel[temp].winid,160,357,"DRIVE D:",FSGoDriveD,temp);
                        filesel[temp].ok=MakeButton(filesel[temp].winid,239,357,"DRIVE E:",FSGoDriveE,temp);
                        filesel[temp].ok=MakeButton(filesel[temp].winid,318,357,"DRIVE F:",FSGoDriveF,temp);
                        filesel[temp].editbox=AddEditBox(filesel[temp].winid,2,374,394,filesel[temp].selection,0,0);
                        filesel[temp].mask=dir;
                        memset(filesel[temp].selection,0,sizeof(filesel[temp].selection));
                        break;
                }
        }while(temp<10);
        //fix up the dir entry
        strcpy(filesel[temp].data,"");
	memset(str,0,60);
        str[0]=(char)(getdisk()+'A');
        strcat(str,":");
	memset(filesel[temp].dir,0,100);
        strcpy(filesel[temp].dir,str);
        AddFileList(temp);
        RefreshListBox(filesel[temp].list);
        editbox[filesel[temp].editbox].hasfocus=1;
        RefreshWin(filesel[temp].winid);
	RefreshWin(mainwin);
};

