/* Sample Ikon Application

        This file was made for use with GCCFI (GCC For Ikon)

*/
#include <ikon.h>          /* ikon.h should ALWAYS be first */
#include <gui.h>

int ourwinid;           //id for our window
int netwinid;		//network setup window id
BITMAP *winbmp;
char imagefile[200];
char ipaddress[80];
char gateway[80];
char dns[80];
char netmask[80];
int colblack;
int colwhite;
void changewall();

void *var_router(DCM *dcm, int function)
{
  return(0);
}

void shutdown(int data)
{
	if(netwinid==0)
	{
	        CloseWin(ourwinid);
	        ExitApp(pid);
	}
};

void wallpaper(int data)
{
        //change the desktop wallpaper
        memset(imagefile,0,sizeof(imagefile));
        FileSelector("*.*",changewall,&imagefile);
};

void changewall()
{
        //display the wallpaper currently on the desktop
        //we get this by reading from the system.ini file
        FILE *systemini;
        char fbuff;
        char buffer[100];
        int temp;
        int cnt;
        systemini=fopen("system\\system.ini","rt");
        fbuff=fgets(buffer,100,systemini);
        fclose(systemini);
        systemini=fopen("system\\system.ini","wt");
        fputs(buffer,systemini);
        memset(buffer,0,sizeof(buffer));
        strcpy(buffer,"wallpaper=");
        strcat(buffer,imagefile);
	strcat(buffer,"\n\r");
        fputs(buffer,systemini);
	fputc('\n',systemini);
	fputc('\r',systemini);
        fclose(systemini);
        ResetWallpaper(imagefile);
	RefreshDesktop();
};

void closenetwin(int date)
{
	CloseWin(netwinid);
	netwinid=0;
}

void savenetsettings(int data)
{
	char buff[300];
	FILE *f;
	int temp;
	f=fopen("wattcp.cfg","w");
	memset(buff,0,300);
	sprintf(buff,"my_ip=%s\nnameserver=%s\nnetmask=%s\ngateway=%s\n",ipaddress,dns,netmask,gateway);
	fputs(buff,f);
	fclose(f);
	CloseWin(netwinid);
	netwinid=0;
	SystemMessage("  Settings Saved!\r\n  You will need to restart\r\n  your computer.");

}

void network(int data)
{
	int temp;
	char buff[100];
	int top;
	int ipbox;
	int netmaskbox;
	int gatewaybox;
	int dnsbox;
	int left2;
	BITMAP *bmp;
	FILE *f;
	if(netwinid!=0)
		return;
	memset(dns,0,80);
	memset(gateway,0,80);
	memset(netmask,0,80);
	memset(ipaddress,0,80);
	top=25;
	left2=(12*7)+19;
	netwinid=MakeWindow(55,10,400,160,"Network Settings",closenetwin,0);
	bmp=GetWinBMP(netwinid);
	textout(bmp,SystemFont(),"IP ADDRESS:",3,top,0);
	ipbox=AddEditBox(netwinid,left2,top,200,ipaddress,0,0);

	textout(bmp,SystemFont(),"   GATEWAY:",3,top+22,0);
	gatewaybox=AddEditBox(netwinid,left2,top+22,200,gateway,0,0);

	textout(bmp,SystemFont(),"   NETMASK:",3,top+44,0);
	netmaskbox=AddEditBox(netwinid,left2,top+44,200,netmask,0,0);

	textout(bmp,SystemFont(),"DNS SERVER:",3,top+66,0);
	dnsbox=AddEditBox(netwinid,left2,top+66,200,dns,0,0);

	//make a save and close button
	MakeButton(netwinid,3,top+90,"Save",savenetsettings,0);
	MakeButton(netwinid,3+(5*9),top+90,"Cancel",closenetwin,0);
	f=fopen("wattcp.cfg","r");
	do{
		memset(buff,0,sizeof(buff));
		temp=fgets(buff,80,f);
		if(temp==0)
			break;
		if(strncmp(buff,"my_ip=",6)==0)
			strncpy(ipaddress,buff+6,strlen(buff)-7);
		if(strncmp(buff,"netmask=",8)==0)
			strncpy(netmask,buff+8,strlen(buff)-9);
		if(strncmp(buff,"gateway=",8)==0)
			strncpy(gateway,buff+8,strlen(buff)-9);
		if(strncmp(buff,"nameserver=",11)==0)
			strncpy(dns,buff+11,strlen(buff)-12);
	}while(1);
	fclose(f);
	RefreshEditBox(ipbox);
	RefreshEditBox(gatewaybox);
	RefreshEditBox(dnsbox);
	RefreshEditBox(netmaskbox);
	RefreshWin(netwinid);

}


static void appmain()
{
  //*********[ Your main program routine ]****************
        int temp;
        InitGUI();
	netwinid=0;
        colblack=makecol(0,0,0);
        colwhite=makecol(0xff,0xff,0xff);
        ourwinid=MakeWindow(50,50,300,400,"Control Panel 1.1",shutdown,0);
        winbmp=GetWinBMP(ourwinid);
        rectfill(winbmp,4,24,295,395,colwhite);
        rect(winbmp,4,24,395,395,colblack);
        MakeIcon(ourwinid,90,30,"icons\\image.bmp","Change Wallpaper",wallpaper,0);
        MakeIcon(ourwinid,90,90,"icons\\network.bmp","Network Settings",network,0);
        RefreshWin(ourwinid);
};



 