/* Sample Ikon Application
*
*	COMPILE: makeapp test
*		-OR-
*	gcc -c test.c -otest.o
*	dxegen test.app _mod_init test.o
*
*/
#include <ikon.h>          /* ikon.h should ALWAYS be first */
#include <gui.h>	/* needed for gui routines */

static void appmain();
int ourwinid;           //id for our window

//***** This function only needs modification for DLL's and drivers****

void *var_router(DCM *dcm, int function)
{
  return(0);
}

//*******************************************************************

void ExitHandler(int data)
{
        if(data==0)
        {       
                CloseWin(ourwinid);	//close our window
                ExitApp(pid);		//exit the application
					//NOTE: pid is a globally define integer
					//that is initialized automatically
					//when your application is run.
					//You DO NOT have to declare it!
        }

};

static void appmain()	//called appmain, not main!!!
{
  //*********[ Your main program routine ]****************
        InitGUI();	//initializes pointers to gui procedures and functions
			//see gui.h to see what it does

	//now we'll make a blank window with 'Hello World' as the caption	
	//ExitHandler is a pointer to the function above, it is called
	//when a user clicks the 'X' in the top right of the window.
        ourwinid=MakeWindow(10,30,300,100,"Hello World",ExitHandler,0);

	//show our window and wait for events
        RefreshWin(ourwinid);
};



